#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <ctype.h>

#include "boolean.h"
#include "macro_be.h"
#include "keyin.h"

boolean_t check_fn(char*);

void cursoroff()
{
   union REGS r;

   r.h.ah = 1;
   r.h.ch = 0x20;
   int86(0x10, &r, &r);
}

void cursoron()
{
   union REGS r;

   r.h.ah = 1;
   r.h.ch = 12;
   r.h.cl = 12;
   int86(0x10, &r, &r);
}

void setinsmode(int ins)
{
   union REGS r;

   r.h.ah = 1;
   r.h.ch = (ins) ? 1 : 12;
   r.h.cl = 12;
   int86(0x10, &r, &r);
}

char *del_space(char *str)
{
   int i, j, len = strlen(str);
   char *s = str;

   for (i = 0, j = 0; i < len; ++i) {
      switch(str[i]) {
	 case ' ' : break;
	  default : s[j] = str[i];
		    j++;
		    break;
      }
   }
   s[j] = '\0';

   return str;
}

#define Prompt_Msg	"F2/F3:Modify  PgDn/PgUp:Next/Prev Page  \x12\x1D:Next/Prev Field  F9:Exit"

void setup_i_layout(char *title, char *author_date)
{
    int i;
   char *s;

   textattr(0x07);
   clrscr();

   s = title;
   gotoxy((80-strlen(s))/2, 1);   cputs(s);
   s = author_date;
   gotoxy(78-strlen(s), 1);   cputs(s);
   gotoxy( 2,  2);  for (i = 2; i < 78; ++i) putch('\xc4');

   gotoxy( 2, 24);  for (i = 2; i < 78; ++i) putch('\xc4');
   s = Prompt_Msg;
   gotoxy((80-strlen(s))/2, 25);   cputs(s);
}

void setalts(i_pat_t *pat, int alts)
{
   pat->ret.alts = alts;
}

#define print_msg(x, y, attr, msg) \
	MACRO_BEGIN \
	   gotoxy(x, y); \
	   textattr(attr); \
	   cputs(msg); \
	MACRO_END

#define clr_msg(x, y, attr, len) \
	MACRO_BEGIN \
	   int i; \
	   gotoxy(x, y); \
	   textattr(attr); \
	   for (i = 0; i < len; i++) cputs(" "); \
	MACRO_END

key_code_t getalts(i_pat_t *pat)
{
   unsigned int  alts = pat->choice.no - 1;
   unsigned int  now = pat->ret.alts;
   unsigned int  x = pat->pos.x, y = pat->pos.y;
   unsigned char **msgs = pat->choice.msgs;
   unsigned int  len;
   unsigned char c;
   boolean_t     over = FALSE;

   cursoroff();

   print_msg(x, y, 0x70, msgs[now]);
   len = strlen(msgs[now]);
   do {
      switch (c = getch()) {
	 case    0 : switch (c = getch()) {
			case    KEYUP :
			case  KEYLEFT :
			case  KEYDOWN :
			case KEYRIGHT :
			case  KEYPGUP :
			case  KEYPGDN :
			case  KEYEXIT : over = TRUE;
					break;
			case KEYMPREV : now = (now == 0) ? alts : --now;
					clr_msg(x, y, 0x07, len);
					print_msg(x, y, 0x70, msgs[now]);
					len = strlen(msgs[now]);
					break;
			case KEYMNEXT : now = (now == alts) ? 0 : ++now;
					clr_msg(x, y, 0x07, len);
					print_msg(x, y, 0x70, msgs[now]);
					len = strlen(msgs[now]);
					break;
		   }
		   break;
	 case '\r' : c = KEYRTN;
		     over = TRUE;
		     break;
      }
   }
   while (!over);

   print_msg(x, y, 0x07, msgs[now])
   pat->ret.alts = now;

   cursoron();

   return (key_code_t) c;
}

key_code_t getstr(i_pat_t *pat)
{
   unsigned int  x = pat->pos.x, y = pat->pos.y;
   unsigned char *s = pat->ret.str, *ss = pat->choice.msgs[0];
   unsigned int  i = 0, len = strlen(ss);
   unsigned int  maxlen = pat->choice.no;
   unsigned int  ins = 0, ii;
   unsigned char c;
   boolean_t     over = FALSE;

   clr_msg(x, y, 0x70, maxlen);
   print_msg(x, y, 0x70, s);

   setinsmode(ins);
   gotoxy(x, y);
   do {
      switch(c = getch()) {
	 case    0 : switch(c = getch()) {
			case  KEYEXIT :
			case  KEYPGUP :
			case  KEYPGDN :
			case    KEYUP :
			case  KEYDOWN : over = TRUE;
					break;
			case  KEYLEFT : if (i) {
					   i--;
					   gotoxy(x+i, y);
					}
					break;
			case KEYRIGHT : if (i < len) {
					   i++;
					   if (i < maxlen) gotoxy(x+i, y);
					}
					break;
			case   KEYINS : setinsmode(ins = !ins);
					break;
			case   KEYDEL : if (*(s+i) && len) {
					   if (i == len)
					      *(s+i) = '\0';
					   else {
					      memcpy(s+i, s+i+1, len-i);
					      cputs(s+i);
					   }
					   gotoxy(x+len-1, y);
					   putch(' ');
					   gotoxy(x+i, y);
					   len -= 1;
					}
					break;
		     }
		     break;
	 case '\r' : c = KEYRTN;
		     over = TRUE;
		     break;
	 case '\b' : if (i && len) {
			memcpy(s+i-1, s+i, len-i+1);
			i--, len--;
			gotoxy(x+i, y);
			cputs(s+i);
			gotoxy(x+len, y);
			putch(' ');
			gotoxy(x+i, y);
		     }
		     break;
	 case '\t' : break;
	 case   27 : break;
	 default   : if (!isprint(c)) break;
		     if (c == ' ') break;
		     if (len >= maxlen && ins) break;
		     if (i >= maxlen) break;

		     putch(c);
		     if (i+1 > len) {
			*(s+i+1) = '\0';
			len = i + 1;
		     }
		     else
			if (ins) {
			   for (ii = len; ii >= i; --ii) s[ii+1] = s[ii];
			   cputs(s+i+1);
			   gotoxy(x+i+1, y);
			   len++;
			}
		     *(s+i) = c;
		     if (++i >= maxlen) gotoxy(x+i-1, y);
		     break;
      }
   }
   while (!over || len == 0);

   setinsmode(0);
   clr_msg(x, y, 0x07, maxlen);
   print_msg(x, y, 0x07, s);

   return (key_code_t) c;
}

void setup_prompt(int entry_no, i_pat_t pat_tbl[])
{
   int i, ret_alts;
   i_pat_t *curnt_pat;

   for (i = 0; i < entry_no; ++i) {
      curnt_pat = pat_tbl+i;
      gotoxy(curnt_pat->prmpt.pos.x, curnt_pat->prmpt.pos.y);
      cputs(curnt_pat->prmpt.s);

      ret_alts = (curnt_pat->choice.no > 1) ? curnt_pat->ret.alts : 0;
      if (curnt_pat->style == GetStr) {
	 if (curnt_pat->ret.str[0] == '\0')
	    strcpy(curnt_pat->ret.str, curnt_pat->choice.msgs[0]);
	 else
	    strcpy(curnt_pat->choice.msgs[0], curnt_pat->ret.str);
	 ret_alts = 0;
     }

     gotoxy(curnt_pat->pos.x, curnt_pat->pos.y);
     cputs(curnt_pat->choice.msgs[ret_alts]);
   }
}

key_code_t drive_input(int entry_no, i_pat_t pat_tbl[])
{
	  int i, ret_alts;
   static int now = 0;
	  int prev, max_entry;
    boolean_t over = FALSE;
      i_pat_t *curnt_pat;
   key_code_t kcode;

   setup_prompt(entry_no, pat_tbl);

   max_entry = entry_no - 1;
   do {
      curnt_pat = pat_tbl + now;
      switch (curnt_pat->style) {
	 case GetAlts : kcode = getalts(curnt_pat);
			break;
	 case  GetStr : kcode = getstr(curnt_pat);
			break;
      }
      switch (kcode) {
	 case     KEYUP :
	 case   KEYLEFT : now = (now == 0) ? max_entry : --now;
			  break;
	 case   KEYDOWN :
	 case  KEYRIGHT : now = (now == max_entry) ? 0 : ++now;
			  break;
	 case   KEYPGUP :
	 case   KEYPGDN : over = TRUE;
			  break;
	 case    KEYRTN : over = (entry_no == 1) ? TRUE : FALSE;
			  if (!over) now = (now == max_entry) ? 0 : ++now;
			  break;
	 case   KEYEXIT : over = TRUE;
			  break;
      }
   } while (!over);

   return kcode;
}

/* void main()
{
   setup_i_layout();
   drive_input(sizeof(pat_tbl) / sizeof(i_pat_t), pat_tbl);
} */