#ifndef _PCI_H
#define _PCI_H

#define PCI_DEVICE_ID_2_PORT  0x0004
#define PCI_DEVICE_ID_4_PORT  0x0001
#define PCI_DEVICE_ID_8_PORT  0x0002
#define PCI_DEVICE_ID_16_PORT 0x0003

#define PCI_DEVICE_ID_2_8255  		0x0101
#define PCI_DEVICE_ID_INDUSTRIAL	0x1011
#define PCI_DEVICE_ID_8_RELAY_8_PHOTO	0x1021
#define PCI_DEVICE_ID_4_RELAY_4_PHOTO	0x1022
#define PCI_DEVICE_ID_16_PHOTO		0x1023
#define PCI_DEVICE_ID_16_RELAY		0x1024

#define PCI_DEVICE_ID_12ADDA		0x0200
#define PCI_DEVICE_ID_14ADDA		0x0201


#define PCI_DEVICE_ID_INDUSTRIAL_OLD	0x0003

#define PCI_SID_AD7899AR1		0x0100
#define PCI_SID_AD7899AR2               0x0101
#define PCI_SID_AD7899AR3               0x0102
#define PCI_SID_AD7899BR1               0x0103
#define PCI_SID_AD7899BR3               0x0104
#define PCI_SID_AD7899SR1               0x0105
#define PCI_SID_AD7899ARS1              0x0106
#define PCI_SID_AD7899ARS2              0x0107
#define PCI_SID_AD7899ARS3              0x0108


#define PCI_VENDER_ID  0x6666


int IsPCIPresent(void);
unsigned int FindPCIDevice(unsigned int);
unsigned int FindPCIClassCode(unsigned int);
unsigned char ReadPCIConfigByte (unsigned int, int);
unsigned int ReadPCIConfigWord (unsigned int, int);
unsigned long ReadPCIConfigDWord (unsigned int, int);
int GetPCICardInfo (unsigned int deviceID, unsigned int *addr, unsigned int *irq);
int GetPCISubsystemID (unsigned int deviceID, unsigned int *pid);

#endif /*_TYPEDEF_H*/
