#ifndef _QC_DA_H

#define _QC_DA_H

#include "macro_be.h"
#include "qc_adv.h"

#define DA_MAX_VOLTAGE 	  	10
#define DA_DOUBLE_MAX_VOLTAGE 	20
#define DA_BITS			12
#define DA_RANGE		(1L << DA_BITS)

#define DA_Config		"Advance DA Configuration"

#define DA_OUT(port, channel, hi, lo) \
	MACRO_BEGIN \
	   if (channel == 0) { \
	      outportb(port+5, hi); \
	      delay(1); \
	      outportb(port+4, lo); \
	      delay(1); \
	      (void) inportb(port+5); \
	   } \
	   else if (channel == 1) { \
	      outportb(port+7, hi); \
	      delay(1); \
	      outportb(port+6, lo); \
	      delay(1); \
	      (void) inportb(port+7); \
	   } \
	MACRO_END

#define DA_Decl_Used \
		char _Data[32]; \
	   const int _Len = 12; \
		long _Index;

#define DA_Real_Voltage(av, board, dvm) \
	MACRO_BEGIN \
	   read_dvm(board, dvm, _Data, _Len); \
	   av = atof(_Data); \
	MACRO_END

#define DA_Ideal_Voltage(cv, i, polar, range) \
	MACRO_BEGIN \
	   cv = (polar == UNIPOLAR) ? ((double)i * DA_MAX_VOLTAGE / (range - 1)) : \
		((double) i * DA_DOUBLE_MAX_VOLTAGE / (range - 1) - DA_MAX_VOLTAGE); \
	MACRO_END

#endif _QC_DA_H